;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
;script .GET Beta
;version 0.01.011 Beta
;release date: 2003-12-02
;Project manager: Urgo
;Coders: Urgo, grimace, knight
;email spam@dotGET.org
;url http://dotGET.org
;dotGET-misc1.mrc: Debugging Data, etc
;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

;alias car { return $left($1,$pos($1,$chr(32),1)) }
alias tcar { return $gettok($1,1,32) }

;alias cdr { return $right($1,$calc($len($1) - $pos($1,$chr(32),1))) }
alias tcdr { return $gettok($1,2-,32) }
alias dotGETd { 
  if ($readini dotGET\dotGET.data main debug == $null) { writeini dotGET\dotGET.data main debug 1 }
  if $window(@.GET) == $null {
    if ($readini dotGET\dotGET.data main debug == 1) {
      window -nhk @.GET @.GET MS Sans Serif 8
    }
    else {
      window -nk @.GET @.GET MS Sans Serif 8
    }
  }
  aline @.GET $timestamp $1-
}

alias dotGETStats { 
  dialog -m dotGETStats dotGETStats
  did -a dotGETStats 39 $fulldate

  ;version
  did -a dotGETStats 12 %dG.origver
  did -a dotGETStats 13 %dG.installdate
  did -a dotGETStats 14 %dotGET.version.number %dotGET.version.type
  did -a dotGETStats 15 %dotGET.installdate

  ;data chan stats
  if (%dotGET.datachan == $null) { did -a dotGETStats 7 N/A } | else { did -a dotGETStats 7 %dotGET.datachan }
  if (%dotGET.datachan == $null) { did -a dotGETStats 28 N/A } | else { did -a dotGETStats 28 $nick(%dotGET.datachan,0) }
  dotGET.filesadd
  did -a dotGETStats 29 %dotGET.global.files
  dotGET.sharedadd
  did -a dotGETStats 30 $dotGETResize(%dotGET.global.shared)

  ;my stats
  did -a dotGETStats 34 %dotGET.shared
  did -a dotGETStats 35 $dotGETResize(%dotGET.sizeshared)

  if ($readini dotGET\dotGET.data stats processed == $null) { did -a dotGETStatus 19 N/A } | else did -a dotGETStats 19 $readini dotGET\dotGET.data stats processed
  if ($readini dotGET\dotGET.data stats requested == $null) { did -a dotGETStatus 26 N/A } | else did -a dotGETStats 26 $readini dotGET\dotGET.data stats requested
  if ($readini dotGET\dotGET.data stats sent == $null) { did -a dotGETStatus 20 N/A } | else did -a dotGETStats 20 $readini dotGET\dotGET.data stats sent

  ;other
  did -a dotGETStats 24 $bytes($file(dotGET\dotGET.status.dat).size,k) $+ kb
  did -a dotGETStats 32 $dotGETResize2($dotGETSend) kb/s
  did -a dotGETStats 37 $dotGETResize2($dotGETRcv) kb/s
}

on *:disconnect:{
  write -il1 dotGET\dotGET.status.dat Session Ended on %dotGET.net at $fulldate
}

alias dotGETStatusLog {
  if $lines(dotGET\dotGET.status.dat) < 2000 {    
    halt
  } 
  elseif ($lines(dotGET\dotGET.status.old) != $null) { 
    .remove dotGET\dotGET.status.old 
    .rename dotGET\dotGET.status.dat dotGET\dotGET.status.old
    write -il1 dotGET\dotGET.status.old Logging terminated to this file on $fulldate $+ . New log continued to dotGET.status.dat.
    write -il1 dotGET\dotGET.status.dat Status log refreshed, to view old log, click on "Previous Log"
    write -il1 dotGET\dotGET.status.dat Listening...
  }
  else { 
    .rename dotGET\dotGET.status.dat dotGET\dotGET.status.old
    write -il1 dotGET\dotGET.status.old Logging terminated to this file on $fulldate $+ . New log continued to dotGET.status.dat.
    write -il1 dotGET\dotGET.status.dat Status log refreshed, to view old log, click on "Previous Log"
    write -il1 dotGET\dotGET.status.dat Listening...
  }
}

dialog dotGETStats {
  title "dotGET Stats"
  size -1 -1 216 144
  option dbu
  text "Original Version", 8, 16 13 39 8, right
  text "Date installed", 9, 16 23 39 8, right
  text "Current Version", 10, 16 37 39 8, right
  text "Date installed", 11, 16 47 39 8, right
  edit "", 13, 57 23 50 9, read
  edit "", 14, 57 37 50 9, read
  edit "", 15, 57 47 50 9, read
  edit "", 19, 57 94 50 9, read
  edit "", 20, 57 104 50 9, read
  button "Ok", 22, 175 130 37 12, default cancel
  text "Status log size", 23, 115 70 39 8, right
  edit "", 24, 156 70 50 9, read
  edit "", 26, 57 114 50 9, read
  box "Version", 3, 3 5 108 55
  box "Data Channel", 5, 115 5 97 55
  edit "", 12, 57 13 50 9, read
  box "My Stats", 31, 3 62 108 65
  text "Stats for", 6, 115 13 39 8, right
  edit "", 7, 156 13 50 9, read
  text "Users", 16, 115 23 39 8, right
  text "Files Shared", 21, 115 33 39 8, right
  text "Amount Shared", 27, 115 43 39 8, right
  edit "", 28, 156 23 50 9, read
  edit "", 29, 156 33 50 9, read
  edit "", 30, 156 43 50 9, read
  text "Searches Processed", 1, 5 94 50 8, right
  text "Files Sent", 2, 16 104 39 8, right
  text "Searches Requested", 4, 5 114 50 8, right
  text "Files Shared", 17, 16 70 39 8, right
  text "Amount Shared", 18, 16 80 39 8, right
  box "Other", 33, 115 62 97 65
  edit "", 34, 57 70 50 9, read
  edit "", 35, 57 80 50 9, read
  text "Uploading", 25, 115 84 39 8, right
  edit "", 32, 156 84 50 9, read
  text "Downloading", 36, 115 94 39 8, right
  edit "", 37, 156 94 50 9, read
  text "Stats taken:", 38, 5 132 36 8
  text "", 39, 43 132 72 8
}

dialog dotGETDisabled {
  title ".GET is disabled??"
  size -1 -1 134 89
  option dbu
  text "You currently have .GET disabled.  If you need to disable the script for temporary reasons then just close this window.  If you do not wish to use .GET anymore please unload the script.", 1, 6 25 114 30
  text ".GET Is disabled??", 2, 37 7 50 8
  button "Enable .GET", 3, 9 68 37 12, ok
  button "Close Window", 4, 82 68 37 12, cancel
}

on *:dialog:dotGETDisabled:*:*: {
  if ($devent == sclick) && ($did == 3) { set %dotGET.disabled 0 }
}

alias dotGET.checkfordisabled {
  if %dotGET.disabled == 1 { dialog -m dotGETDisabled dotGETDisabled }
}

ctcp ^*:VERSION:* { .ctcpreply $nick .GET %dotGET.version Total Searches Processed: $readini(dotGET\dotGET.data,stats,processed) -- Files Sent: $readini(dotGET\dotGET.data,stats,sent)  -- Originally loaded %dG.origver on %dG.installdate $+ , and have been running .GET for $duration($calc($ctime - %dG.installtime)) $+ . - Debug $readini(dotGET\dotGET.data,main,debug) Build $dotGET.verhash $+ $dotGET-filecheck  | halt }

dialog dotGETUpdate {
  title "Update .GET NOW!"
  size -1 -1 115 68
  option dbu
  text "There is an update for .GET BETA NOW! Contact #dotGET on irc.dotGET.net or visit www.dotGET.net ASAP to get the update =]", 1, 16 5 78 35
  button "Close", 2, 16 47 37 12, default ok
  button "Web Page", 3, 55 47 37 12, default
}


on *:dialog:dotGETUpdate:*:*: {
  if ($devent == sclick) && ($did == 2) { if (Urgo ison #dotGET) { .msg urgo .GET: Gimme update! (Version %dotGET.version.name %dotGET.version.number %dotGET.version.type $+ ) } }
  if ($devent == sclick) && ($did == 3) { url -an http://dotGET.org/update.html | dialog -k dotGETUpdate }
}


alias dotGET.verhash {
  ;  var %lines = $calc($lines(dotGET\dotGET.mrc) + $lines(dotGET\dotGET-db.mrc) + $lines(dotGET\dotGET-setup.mrc) + $lines(dotGET\dotGET-rsearch.mrc) + $lines(dotGET\dotGET-mysearch.mrc) + $lines(dotGET\dotGET-queue.mrc) + $lines(dotGET\dotGET-misc1.mrc))
  ;  var %size = $calc($file(dotGET\dotGET.mrc).size + $file(dotGET\dotGET-db.mrc).size + $file(dotGET\dotGET-setup.mrc).size + $file(dotGET\dotGET-rsearch.mrc).size + $file(dotGET\dotGET-mysearch.mrc).size + $file(dotGET\dotGET-queue.mrc).size + $file(dotGET\dotGET-misc1.mrc).size)
  ;  return $calc($calc(%size + %lines) / 1000)
  var %crc = $calc($dotGETcrc(dotGET\dotGET.mrc) + $dotGETcrc(dotGET\dotGET-db.mrc) + $dotGETcrc(dotGET\dotGET-setup.mrc) + $dotGETcrc(dotGET\dotGET-rsearch.mrc) + $dotGETcrc(dotGET\dotGET-mysearch.mrc) + $dotGETcrc(dotGET\dotGET-queue.mrc) + $dotGETcrc(dotGET\dotGET-misc1.mrc))
  return %crc
}
alias dotGETcrc {
  var %crc = $crc($1)
  %num = $calc($asc($right($left(%crc,1),1)) + $asc($right($left(%crc,2),1)) + $asc($right($left(%crc,3),1)) + $asc($right($left(%crc,4),1)) + $asc($right($left(%crc,5),1)) + $asc($right($left(%crc,6),1)) + $asc($right($left(%crc,7),1)) + $asc($right($left(%crc,8),1)))
  return %num
}

alias dotGET.checkforfirewall {
  if (($calc($ctime - %dotGET.searchedlast) < 20) || (%dotGET.myip == $null)) {
    .timerdotGETcfw 1 5 dotGET.checkforfirewall
  }
  else {
    set %dotGET.searchedlast $ctime
    if ($dialog(dotGETFirewalled)) { dialog -c dotGETFirewalled }
    if ($dialog(dotGETFirewalledMAYBE)) { dialog -c dotGETFirewalledMAYBE }
    if ((%dotGET.firewall != $null) && (%dotGET.firewall != 0)) { var %dotGET.port = %dotGET.firewall
      if $portfree(%dotGET.port) != $true { dotGETbadport | return }
    }
    else {
      :checkforport
      var %dotGET.port = $rand(1024,5000)
      if $portfree(%dotGET.port) != $true { goto checkforport }
    }
    .timerdotGET.FWTest 1 20 dotGET.FWTestPositive
    sockclose dotGET.FWTest.in
    socklisten dotGET.FWTest.in %dotGET.port
    .msg %dotGET.datachan .search %dotGET.myip %dotGET.port .GET all FIREWALLTEST
  }
}
on 1:socklisten:dotGET.FWTest.in: { 
  .timerdotGET.FWTest off
  echo -s [.GET] You are not firewalled
  sockclose dotGET.FWTest.in
}
alias dotGET.FWTestPositive {
  if ($nick(%dotGET.datachan,0) > 20) { dialog -m dotGETFirewalled dotGETFirewalled }
  else { dialog -m dotGETFirewalledMAYBE dotGETFirewalledMAYBE }
}

dialog dotGETFirewalled {
  title ".GET - You **ARE** firewalled!"
  size -1 -1 157 141
  option dbu
  box "Your options:", 1, 2 0 151 136
  text ".GET's firewall auto-detection test has decided that you **ARE** behind a firewall or a router.", 2, 6 12 139 17
  text "We highly recomend visiting the FAQ @ http://www.dotGET.org to learn how to enable port forwarding.", 3, 6 55 138 22
  text "If this is too hard for you, you can choose to turn on firewall/router support by clicking below.", 4, 6 80 138 18
  button "Visit FAQ", 5, 7 108 40 24, ok
  button "Enable Firewall/ Router Support", 6, 109 108 40 24, multi
  button "Ignore", 7, 57 108 40 24, cancel
}

dialog dotGETFirewalledMAYBE {
  title ".GET - You **MIGHT BE** firewalled!"
  size -1 -1 157 141
  option dbu
  box "Your options:", 1, 2 0 151 136
  text ".GET's firewall auto-detection test has decided that you **MIGHT BE** behind a firewall or a router.", 2, 6 12 139 17
  text "We highly recomend visiting the FAQ @ http://www.dotGET.org to learn how to enable port forwarding.", 3, 6 55 138 22
  text "If this is too hard for you, you can choose to turn on firewall/router support by clicking below.", 4, 6 80 138 18
  button "Visit FAQ", 5, 7 108 40 24, ok
  button "Enable Firewall/ Router Support", 6, 109 108 40 24, multi
  button "Ignore", 7, 57 108 40 24, cancel
  text "There are not enough people in the data channel to get an accurate reading. (Ignore this if you are not)", 8, 6 33 137 18
}

on *:dialog:dotGETFirewalled*:*:*: {
  if ($devent == sclick) && ($did == 5) { url -an http://dotGET.org/faqs.html }
  if ($devent == sclick) && ($did == 7) { }
  if ($devent == sclick) && ($did == 6) {
    if ($dialog(dotGETFirewalled)) { dialog -c dotGETFirewalled }
    if ($dialog(dotGETFirewalledMAYBE)) { dialog -c dotGETFirewalledMAYBE }
    .msg %dotGET.datachan Port 0 Firewall/Router Support Enabled
    set %dotGET.firewall 0
  }

}

;;relay code not funtional yet

alias dotGET.relay.setup {
  echo -s .1. $1 2. $2 3. $3 4. $4
  :checkforport1
  var %dotGET.dataIN = $rand(1024,5000)
  if $portfree(%dotGET.dataIN) != $true { goto checkforport1 }
  :checkforport2
  var %dotGET.dataOUT = $rand(1024,5000)
  if (($portfree(%dotGET.dataOUT) != $true) || (%dotGET.dataIN == %dotGET.dataOUT)) { goto checkforport2 }
  echo -s port1: %dotGET.dataIN port2: %dotGET.dataOUT
  ;dataIN  = port that the person with results connects to
  ;dataOUT = the port the searcher connects to
  socklisten dotGET.relay.IN.listen %dotGET.dataIN
  socklisten dotGET.relay.OUT.listen %dotGET.dataOUT
  set %dotGET.relay.readytosend 0
  set %dotGET.relay.readytorecieve 0
  write -c dotGET\dotGET.firewallbuffer.txt
  if ($1 == local) {
    echo -s accepting search results from local host
    ctcp $2 .get firewall.workaround $+ $3 %dotGET.myip %dotGET.dataOUT
    sockopen dotGETSendSearch 127.0.0.1 %dotGET.dataIN

  }
  else {
    echo -s relay is now open for remote host to connect to.. closing in 30 seconds
  }
  .timerdotGET.relayABORT 1 90 dotGET.relayABORT
}

alias dotGET.relayABORT {
  echo -s .GET Aborting Relay 
  sockclose dotGET.relay.*
  set %dotGET.searchinprogress 0
}
on 1:socklisten:dotGET.relay.IN.listen: { 
  sockaccept dotGET.relay.IN
  echo -s IN CONNECTED
  set %dotGET.relay.readytosend 1
  dotGET.relay.ready
  sockclose dotGET.relay.IN.listen
}

on 1:socklisten:dotGET.relay.OUT.listen: { 
  sockaccept dotGET.relay.OUT
  echo -s OUT CONNECTED
  set %dotGET.relay.readytorecieve 1
  dotGET.relay.ready
  sockclose dotGET.relay.OUT.listen
}

on 1:sockread:dotGET.relay.IN:{
  sockread %dotGET.relay.IN.text
  if (%dotGET.relay.readytorecieve == 1) { echo -s !! %dotGET.relay.IN.text | sockwrite -n dotGET.relay.OUT %dotGET.relay.IN.text }
  else { write dotGET\dotGET.firewallbuffer.txt %dotGET.relay.IN.text | echo -s buffering }
}

on 1:sockread:dotGET.relay.OUT:{
  sockread %dotGET.relay.OUT.text
  echo -s . %dotGET.relay.OUT.text
  echo -s It worked: %dotGET.relay.OUT.text
}
alias dotGET.relay.ready {
  if ((%dotGET.relay.readytosend == 1) && (%dotGET.relay.readytorecieve == 1)) {
    ; sockwrite -n dotGET.relay.IN Relay Established.
    :start
    if $lines(dotGET\dotGET.firewallbuffer.txt) > 0) {
      sockwrite -n dotGET.relay.OUT $read -l1 dotGET\dotGET.firewallbuffer.txt
      write -dl1 dotGET\dotGET.firewallbuffer.txt
      goto start
    }
  }
}
alias dotGETF {
  if ($1 == $null) { return ? }
  else { return $1- }
}
alias dotGETzerofix {
  if ($1 == 0) { return 1 }
  else { return $1- }
}
alias dotGET-filecheck {
  if ($script($mircdir $+ dotGET\ $+ dotGET.mrc) == $null) { return -1 }
  if ($script($mircdir $+ dotGET\ $+ dotGET-db.mrc) == $null) { return -2 }
  if ($script($mircdir $+ dotGET\ $+ dotGET-setup.mrc) == $null) { return -3 }
  if ($script($mircdir $+ dotGET\ $+ dotGET-rsearch.mrc) == $null) { return -4 }
  if ($script($mircdir $+ dotGET\ $+ dotGET-mysearch.mrc) == $null) { return -5 }
  if ($script($mircdir $+ dotGET\ $+ dotGET-queue.mrc) == $null) { return -6 }
  if ($script($mircdir $+ dotGET\ $+ dotGET-misc1.mrc) == $null) { return -7 }
  return !
}
;CRC PADDING;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
